;JM's Memory Resident Gray Scale Loader
;Version 1.0
;Written 01/25/2000

;Please place the following line into your documentation
; if you use this algorithm, (Just changing the include...)

;"This program uses the memory block at RAM1:0000. This may
; overwrite an existing memory resident program"
;(Note - RAM1:0000 is my notation for Page 1 address 0000
; because it makes alot more since when referring in ahl!)

;Just in case your not the only one using this method. :-)

;This Program Loads:

;*******************************************************************
;*           GRAY SCALE LIBRARY FOR TI-86 VERSION 1.0              *
;*                 Written by Robert Niedziela                     *
;*                             1998                                *
;*-----------------------------------------------------------------*
;* This is the library of basic routines for gray scale graph mode *
;* Version for 8 levels of gray without double buffering           *
;*-----------------------------------------------------------------*
;* There is variable UserCounter which is incremented every        *
;* interrupt - use it if you need any counter.                     *
;*******************************************************************

;into An Allocated section of the FPS.


;Program Entry Points are at:

;OpenGray = $8004
;CloseGray = $804f
;ClearPages = $8066


;Variables are at memory locations:

;UserCounter = $D33E
;Page1 = $FC00
;Page2 = $CA00
;Page3 = $F500


;Note from the Author:

;I like to program in machine language on my 86 at school,
;(A.K.A. I program in assembler ON the calc using AsmPrgm and
; opcodes) but I also like to program grayscale pictures. (If
; you want one, E-Mail me, I'm getting pretty good :-> ) so
; I wanted a method to program in grays without spending all of
; my time typing in the grayscale library, (Thanx Robert Niedziela)
; so this program was concieved. It's delivery had to wait till I
; got home so I could implement my ideas. And as a result of boredom
; I started dreaming up the best way to do this. Well, since I carry
; a 1 inch binder of draft mode dot-matrix printouts on everything
; relating to 86 assembler, I stumbled into some information on the
; Floating Point Stack (Refered to from here on as the FPS) and it's
; properties. Well, after thinking about it, I decided that the best
; way to store this routine was to move the FPS down and place the
; GSL at the VERY top of ram page 1. This way I could be almost
; assured that nothing would overwrite it. As a result though, it is
; useful to place any memory resident program there and not disturb
; anything else. The only thing that I have to know now is the variable
; locations and the routine entry points. So, I used the symbol table
; and have conviently placed them in the code. BUT make VERY sure that
; you load PAGE 1 before you call any of the routines!!!

;By the way, the fact that ALL of my addresses, like FPS or _newline are
; resolved into their ACTUALL values is a side effect of programming in
; machine language. (You just have to know them. Like $4A33 is _DispAHL)
; Also if there is a mistake in the call, don't be suprised if the MSB
; and the LSB are mixed, like _puts being referred to as $374A. That's
; just the way the Z80 reads it, but ASM Studio expects the MSB first.

;Feel free to use my program, part of my program, my concept, or anything else,
; But if you use the GSL include credit Robert Niedziela and if you use my stuff,
; credit me, and - maybe - drop me an e-mail and show me what you've done with my
; code!

;Thanks to all that helped me, Directly and Indirectly!
; STL - For listening to me even though it means nothing to a TI-92+ owner. :->
; Robert Niedziela - For the ULTRA-Cool GSL!
; TICalc.org - For being an invaluable resource of information!
; Andrew Ess - For writing USGARD. The shell I learned Z80 programming on.
; Dux Gregis - For the Memory Map! (FPSBase and FPS are the KEYS!!!)
; TI - For making an easily availible platform for development.
; Alen Bailey - For 86ports.txt, the BEST resource on ports 5 and 6!
; Jeremy Goetsh - Assembly Studio 3.1 (Although some times a little flakey) is the
;                  best Z80 development IDE!
; Sam - For looking at me and nodding while I was making a fool of myself trying
;        to work this algorithm out.
; And anyone else I haven't thought of

;Signed,
; John-Michael O'Brien - Visit http://members.aol.com/kb0lzu!


#define FPSLOAD_VER = 1.0

#include "asm86.h"
#include "ti86asm.inc"
.org $D748

#ifdef __ASMIDE_VER
.warning This program was written by John-Michael O'Brien
.warning E-Mail questions and comments to him at JMProduct@aol.com
.warning If you use my code in your program, give me and Robert Niedziela credit.
#endif
FPSBuff = $E000

ProgStart:
;Load Page 1 (Contains FPS)
 ld A,$41
 out (6),A

;Check for Page Header
 ld a,($8000)
 cp $4A
 jp NZ,TFPS
 ld a,($8001)
 cp $4D
 jp NZ,TFPS
 ld a,($8002)
 cp $38
 jp NZ,TFPS
 ld a,($8003)
 cp $47
 jp NZ,TFPS

;If you're here, the page header was found so say "Allready Installed!"
 ld hl,AInst
 call $4A37
 call $4A5F
 ret

TFPS:
;Transfer FPS to Temporary Buffer
 ld de,$8000
 add hl,de
 ld de,FPSBuff
 ld bc,($D28D)
 ldir

;Load Program into FPS Memory Space
 ld hl,libData
 ld de,$8000
 ld bc,libEnd-libStart
 ldir

;Adjust Stack Base
 ld bc,libEnd
 ld ($D28B),bc

;Copy The Stack Back
 ld bc,($D28D)
 ld hl,FPSBuff
 ld de,libEnd
 ldir

;Adjust the Stack Pointer
 ld hl,($D28D)
 ld de,libEnd
 add hl,de
 ld ($D28d),hl

 ld hl,DInst
 call $4A37
 call $4A5F 
 ret

AInst:
 .db "Allready Installed!",0
DInst:
 .db "8Gray Lib Installed!",0

libData:
.org $8000
libStart:
.db "JM8G"
#include "gsl8_86.asm"
libEnd:
.end



